var list=[];
var exist=[];
function HttpGet(url,cb){
	var http=new XMLHttpRequest();
	http.open("GET",url);
	http.onreadystatechange=function(){
		if(http.readyState==4){
			cb(http.responseText);
		}
	}
	http.send();
}
function FeedGet(url,cb){
	for(var i=0;i<url.length;i++){
		(function(i){
			HttpGet(url[i],function(file){
				if(file.match(/<feed\W/)){
					ParseAtom(file);
				}else{
					ParseRss(file);
				}
				list=list.sort(function(a,b){
					if(exist[a.url]<exist[b.url]) return 1;
					if(exist[a.url]>exist[b.url]) return -1;
					return 0;
				});
				if(i==url.length-1) cb(list);
			});
		})(i);
	}
}
function ParseAtom(file){
	var item=file.match(/<entry\W[\s\S]*?<\/entry>/g);
	for(var i=0;i<item.length;i++){
		var id="";
		var url="";
		var title="";
		var desc="";
		var date=new Date();
		if(item[i].match(/<id>([^<]*)<\/id>/)) id=RegExp.$1;
		if(item[i].match(/<link [^>]*href\s*=[\s"']*([^\s"'>]*)/)) url=RegExp.$1;
		if(item[i].match(/<title[^>]*>([^<]*)<\/title>/)) title=RegExp.$1;
		if(item[i].match(/<summary[^>]*>([^<]*)<\/summary>/)) desc=RegExp.$1;
		if(item[i].match(/<updated[^>]*>([^<]*)<\/updated>/)) date=new Date(RegExp.$1);
		url=HtmlEscapeU(url);
		id=id||url;
		if(url && title && !exist[url]){
			title=HtmlEscapeU(title);
			desc=HtmlEscapeU(desc);
			exist[id]=date.getTime();
			list.push({"url":url,"title":title,"desc":desc,"date":date.toISOString()});
		}
	}
}
function ParseRss(file){
	var item=file.match(/<item\W[\s\S]*?<\/item>/g);
	for(var i=0;i<item.length;i++){
		var url="";
		var title="";
		var desc="";
		var date=new Date();
		if(item[i].match(/<link[^>]*>([^<]*)<\/link>/)) url=RegExp.$1;
		if(item[i].match(/<title[^>]*>([^<]*)<\/title>/)) title=RegExp.$1;
		if(item[i].match(/<description[^>]*>([^<]*)<\/description>/)) desc=RegExp.$1;
		if(item[i].match(/<dc:date[^>]*>([^<]*)<\/dc:date>/)){
			date=new Date(RegExp.$1);
		}else if(item[i].match(/<pubDate[^>]*>([^<]*)<\/pubDate>/)){
			date=new Date(RegExp.$1);
		}
		if(url && title && !exist[url]){
			url=HtmlEscapeU(url);
			title=HtmlEscapeU(title);
			desc=HtmlEscapeU(desc);
			exist[url]=date.getTime();
			list.push({"url":url,"title":title,"desc":desc,"date":date.toISOString()});
		}
	}
}
function HtmlEscapeU(str){
	str=str.replace(/&#(\d+);/g,function(m,$1){return String.fromCharCode($1);});
	str=str.replace(/&quot;/g,'"');
	str=str.replace(/&amp;/g,'&');
	return str;
}
