import QtQuick 2.5
import QtQml 2.2
import org.kde.plasma.plasmoid 2.0
import "script.js" as JavaScript

ListView{
	property string feed: plasmoid.configuration.feed;
	ListModel{id:model}
	model:model
	delegate:Text{
		width:parent.width
		wrapMode:Text.WordWrap
		color:"blue"
		text:title
		MouseArea{
			anchors.fill:parent
			cursorShape:Qt.PointingHandCursor
			onClicked:Qt.openUrlExternally(url)
		}
	}
	Timer{
		id:timer
		repeat:true
		interval:60*60*1000
		onTriggered:listUpdate()
	}
	Component.onCompleted:{
		timer.start();
		listUpdate();
	}
	function listUpdate(){
		if(!feed.match(/^https?:/)) return;
		JavaScript.FeedGet([feed],function(list){
			model.clear();
			for(var i=0;i<list.length;i++){
				model.append(list[i]);
			}
		});
	}
}
